/*
 *	this is a sample program that uses the serial port queue module. note that
 *	it does not contain any error handling routines.
 *
 *	how to run this?
 *
 *		0) make sure you are connected to a handy board.
 *		1) go into IC.
 *		2) load init.lis. this loads all the necessary files for you.
 *		3) turn off the board.
 *		4) exit IC. (since we will be disabling the pcode_serial function)
 *		5) go into your comm application of choice. (be sure the port settings are correct)
 *		6) start typing real fast.
 *		7) watch the handy board screen.
 *		8) to stop the demo, press the stop button on the handy board.
 *
 *	requires:
 *	sciint.icb
 *	serialq.c
 *	serial.c
 *
 *	created:
 *	jun 02 1999 jaime montemayor <monte@cs.umd.edu>
 *
 *	modified:
 *	n/a
 *
 */
 

void main()
{

	int msg;
	int err;
	
	printf("serial queue demo. <start>\n");
	start_press();
	
	disable_pcode_serial();

	serialq_init();	
	
	printf("ready to listen\n");
	while (!stop_button()) {

		err = serialq_get_nb(&msg);
		
		if (err == SQ_OK) {	
			/* got a byte from the queue */	
			if ((msg == 10) || (msg == 9) || (msg == 13)) {
				printf("\n");
			}
			else {
				printf("%c",msg);
			}	
			
		}
		else if (err == SQ_EMPTY) {
			/* do nothing */
		}
		else if (err == SQ_TIMEDOUT) {
			beep();
		}
		else if (err == SQ_OVERFLOW) {
			beep();beep();beep();beep();beep();
			serial_cc_reset();
			serialq_init();
		}		
	
	} /* while... endless loop */
	
	
	reenable_pcode_serial();
	beep();beep();beep();
	printf("bye.\n");
	

}
