/* ----------------- SENDING AND RECEIVING THROUGH THE SERIAL LINE -----------


the IC program must be stopped in order for this to work !
the code is from the handybaord FAQ by 
   Fred Martin or ?? Randy Sargent ??
added by Xavier Chabot, 3-3-97:

serial_getchar2()
   >>> receiving from the serial port:
disable_pcode_serial()
   >>> prevents the onboard pcode to catch the incoming
       serial data
reenable_pcode_serial(void)
   >>> reestablishes connection
serial_getchar()
   >>> returns a character send from the computer
   
   

sending to the serial port:
blocking: serial_getchar(): waits until a character is sent
the character is return as int

non blocking: serial_getchar2(&val) checks if there is a character to be
read. the character is written at the address val. returns 0 if there is
something, -1 if there is nothing

*/


/* --------------- READ from serial port  ------------------- */
void disable_pcode_serial(void)
{
 poke(0x3c,1);
}

void reenable_pcode_serial(void)
{
 poke(0x3c,0);
}

/*  blocking read */
int serial_getchar()
{
 while(!(peek(0x102e) & 0x20)); /* wait UART */
 return peek(0x102f);
}

/* test UART and get char but no wait */
int serial_getchar2(int *val)
{
 if (peek(0x102e) & 0x20) /*  UART ready? */
 {
  *val = peek(0x102f);
  return 0;
 }
 return -1; 
}

/* --------------------- WRITE to serial port --------------------------*/
/* writes a character to the serial port - blocks until free */
void serial_putchar(int c)
{
 while (!(peek(0x102e) & 0x80) ); /* wait UART */
 poke(0x102f, c);
}
